// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'smiupdate.pas' rev: 6.00

#ifndef smiupdateHPP
#define smiupdateHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SMInStat.hpp>	// Pascal unit
#include <SMInBase.hpp>	// Pascal unit
#include <WinInet.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smiupdate
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMIService { isHTTP, isHTTPS, isFTP, isNetwork };
#pragma option pop

#pragma option push -b-
enum TSMIStatus { isInProgress, isFinished, isFailed, isSkipped, isNotFound };
#pragma option pop

#pragma option push -b-
enum TSMIAction { iaIdle, iaConnecting, iaConnected, iaDisconnecting, iaDisconnected, iaFileSearch, iaFileFound, iaComparing, iaCompared, iaDownloading, iaDownloaded };
#pragma option pop

typedef void __fastcall (__closure *TSMIProgress)(System::TObject* Sender, int CurValue, int MaxValue, bool &Abort);

class DELPHICLASS TSMInetStatusDialog;
class PASCALIMPLEMENTATION TSMInetStatusDialog : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	Classes::THelpContext FHelpContext;
	AnsiString FTitle;
	AnsiString FDescription;
	Graphics::TPicture* FPicture;
	Graphics::TIcon* FIcon;
	Graphics::TPicture* __fastcall GetPicture(void);
	void __fastcall SetPicture(Graphics::TPicture* Value);
	Graphics::TIcon* __fastcall GetIcon(void);
	void __fastcall SetIcon(Graphics::TIcon* Value);
	
public:
	__fastcall virtual TSMInetStatusDialog(void);
	__fastcall virtual ~TSMInetStatusDialog(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property Classes::THelpContext HelpContext = {read=FHelpContext, write=FHelpContext, default=0};
	__property Graphics::TPicture* Picture = {read=GetPicture, write=SetPicture};
	__property Graphics::TIcon* Icon = {read=GetIcon, write=SetIcon};
	__property AnsiString Title = {read=FTitle, write=FTitle};
	__property AnsiString Description = {read=FDescription, write=FDescription};
};


class DELPHICLASS TSMCustomWebComponent;
class PASCALIMPLEMENTATION TSMCustomWebComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FWEBAgent;
	Word FWEBPort;
	AnsiString FWEBHost;
	AnsiString FWEBUser;
	AnsiString FWEBPassword;
	TSMIService FService;
	TSMIStatus FStatus;
	TSMIAction FAction;
	Sminbase::TSMInetProxy* FProxy;
	TSMInetStatusDialog* FStatusDialog;
	bool FLoginPrompt;
	TSMIProgress FOnProgress;
	Classes::TNotifyEvent FOnActionChange;
	Classes::TNotifyEvent FOnStatusChange;
	Classes::TNotifyEvent FOnBeforeExecute;
	Classes::TNotifyEvent FOnAfterExecute;
	void __fastcall SetProxy(Sminbase::TSMInetProxy* Value);
	void __fastcall SetStatusDialog(TSMInetStatusDialog* Value);
	void __fastcall SetStatus(TSMIStatus Value);
	void __fastcall SetAction(TSMIAction Value);
	void __fastcall SetService(TSMIService Value);
	
protected:
	void *hInet;
	void *hURL;
	void *hFindFile;
	Sminstat::TfrmSMInetUpdate* dlgStatus;
	virtual void __fastcall InternalExecute(void) = 0 ;
	void __fastcall UpdateProgress(unsigned BytesTotalRead, unsigned RemoteFileSize, bool &Abort);
	void __fastcall ConnectToInet(void);
	void __fastcall DisconnectFromInet(void);
	bool __fastcall GetFileInfoFromInet(const AnsiString RemoteFileName, unsigned &RemoteFileSize, _FILETIME &RemoteFileCreated);
	bool __fastcall ReadFileFromInet(const AnsiString RemoteFileName, const AnsiString LocalFileName, unsigned RemoteFileSize);
	bool __fastcall ReadDirFromInet(const AnsiString Directory, const AnsiString WildCard, bool SubFolder, Classes::TStrings* lst);
	
public:
	__fastcall virtual TSMCustomWebComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMCustomWebComponent(void);
	virtual bool __fastcall Execute(void);
	__property TSMIAction Action = {read=FAction, write=SetAction, nodefault};
	__property TSMIStatus Status = {read=FStatus, write=SetStatus, nodefault};
	
__published:
	__property AnsiString Agent = {read=FWEBAgent, write=FWEBAgent};
	__property Word Port = {read=FWEBPort, write=FWEBPort, nodefault};
	__property TSMIService Service = {read=FService, write=SetService, default=0};
	__property AnsiString Host = {read=FWEBHost, write=FWEBHost};
	__property AnsiString User = {read=FWEBUser, write=FWEBUser};
	__property AnsiString Password = {read=FWEBPassword, write=FWEBPassword};
	__property Sminbase::TSMInetProxy* Proxy = {read=FProxy, write=SetProxy};
	__property TSMInetStatusDialog* StatusDialog = {read=FStatusDialog, write=SetStatusDialog};
	__property bool LoginPrompt = {read=FLoginPrompt, write=FLoginPrompt, default=1};
	__property TSMIProgress OnProgress = {read=FOnProgress, write=FOnProgress};
	__property Classes::TNotifyEvent OnBeforeExecute = {read=FOnBeforeExecute, write=FOnBeforeExecute};
	__property Classes::TNotifyEvent OnAfterExecute = {read=FOnAfterExecute, write=FOnAfterExecute};
	__property Classes::TNotifyEvent OnActionChange = {read=FOnActionChange, write=FOnActionChange};
	__property Classes::TNotifyEvent OnStatusChange = {read=FOnStatusChange, write=FOnStatusChange};
};


typedef void __fastcall (__closure *TSMIFileCompare)(System::TObject* Sender, bool &Equal);

class DELPHICLASS TSMCustomWebUpdater;
class PASCALIMPLEMENTATION TSMCustomWebUpdater : public TSMCustomWebComponent 
{
	typedef TSMCustomWebComponent inherited;
	
private:
	unsigned FRemoteFileSize;
	_FILETIME FRemoteFileCreated;
	AnsiString FRemoteFileName;
	AnsiString FLocalFileName;
	TSMIFileCompare FOnFileCompare;
	
protected:
	virtual void __fastcall SetRemoteFileName(AnsiString Value);
	__property AnsiString LocalFileName = {read=FLocalFileName, write=FLocalFileName};
	
public:
	virtual void __fastcall InternalExecute(void);
	__property unsigned RemoteFileSize = {read=FRemoteFileSize, nodefault};
	__property _FILETIME RemoteFileCreated = {read=FRemoteFileCreated};
	
__published:
	__property AnsiString RemoteFileName = {read=FRemoteFileName, write=SetRemoteFileName};
	__property TSMIFileCompare OnFileCompare = {read=FOnFileCompare, write=FOnFileCompare};
public:
	#pragma option push -w-inl
	/* TSMCustomWebComponent.Create */ inline __fastcall virtual TSMCustomWebUpdater(Classes::TComponent* AOwner) : TSMCustomWebComponent(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMCustomWebComponent.Destroy */ inline __fastcall virtual ~TSMCustomWebUpdater(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMWebUpdater;
class PASCALIMPLEMENTATION TSMWebUpdater : public TSMCustomWebUpdater 
{
	typedef TSMCustomWebUpdater inherited;
	
__published:
	__property LocalFileName ;
public:
	#pragma option push -w-inl
	/* TSMCustomWebComponent.Create */ inline __fastcall virtual TSMWebUpdater(Classes::TComponent* AOwner) : TSMCustomWebUpdater(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMCustomWebComponent.Destroy */ inline __fastcall virtual ~TSMWebUpdater(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Smiupdate */
using namespace Smiupdate;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// smiupdate
